//===================================================================
//  RX621 eXgvO(5) AiOo
//
//  (c)2021 SUWA TSUSHIN NETWORK.  https://www.suwatsu.com/hobby/index.htm
//===================================================================

#include "iodefine.h"    // WX^ǂݏp
#include "math.h"        // Op֐Zp

#pragma interrupt init_irq14 (vect=78)    // IRQ14
#pragma interrupt init_cmt0 (vect=28)     // CMT0 CMI0
#pragma interrupt init_cmt1 (vect=29)     // CMT1 CMI1
#pragma interrupt init_AN0 (vect=98)      // ADI0
#pragma interrupt init_mtu6 (vect=142)    // MTU6 TGIA6
#pragma interrupt init_mtu11 (vect=169)   // MTU11 TGIW11

void init_AN0(void);
void init_irq14(void);
void init_cmt0(void);
void init_cmt1(void);
void init_mtu6(void);
void init_mtu11(void);
void main(void);


unsigned long cmt0_cnt = 0;     // CMT0p^C}JE^
unsigned long mtu6_cnt = 0;     // MTU6pJE^obt@


// ----------------------- AiOo͗p
double start_level = 511.5;   // sing00180xl
double sin_cnt = 0;           // singvbgpJE^
double sin_prot_max = 180;    // singvbg

// 
double an0_dat;               // AN0 ͒l
double an0_dat_MAX = 899;     // AN0 ͍ől i= 2.9Vj


void main(void)
{
	
	
	// WDT --------------------------------------------------------------------
	
	WDT.WRITE.WINB = 0x5A5F;      // WDT ݒ RSTE=1
	WDT.WRITE.WINA = 0xA5FC;      // WDT ݒ TMS=1,TME=1
	
	
	// fW^o --------------------------------------------------------------------
	
	PORT4.ICR.BIT.B6 = 1;         // P46 ̓|[gɐݒ
	PORTD.ICR.BIT.B2 = 1;         // PD2 ̓|[gɐݒ
	
	PORTA.DDR.BIT.B0 = 1;         // PA0 o̓|[gɐݒ
	PORTA.DDR.BIT.B2 = 1;         // PA2 o̓|[gɐݒ

	PORTA.DR.BIT.B0 = 0;	      //  PA0 o Lo
	PORTA.DR.BIT.B2 = 0;	      //  PA2 o Lo
	
	
	// ݓ --------------------------------------------------------------------
	
	ICU.IRQCR[14].BIT.IRQMD = 1;        // IRQoݒrbg 0b01FGbW
	ICU.IPR[0x2E].BIT.IPR = 0xE;        // ݃x 15(ō)
	ICU.IR[78].BIT.IR = 0;              // ݃Xe[^XWX^Zbg
	ICU.IER[0x9].BIT.IEN6 = 1;          // IRQ14(vect=78) ݋
	
	
	// CMT0 --------------------------------------------------------------------	
	
	SYSTEM.MSTPCRA.BIT.MSTPA15 = 0;     // CMTjbg0iCMT0ACMT1j 0FW[XgbvԂ̉
	
	CMT0.CMCR.BIT.CKS = 1;              // NbNI 1FPCLK/32
	CMT0.CMCR.BIT.CMIE = 1;             // 1FRyA}b`荞݁iCMInj

	ICU.IR[28].BIT.IR = 0;              // ݃Xe[^XWX^Zbg
	ICU.IPR[0x04].BIT.IPR = 0xE;        // ݃x 15(ō)
	ICU.IER[0x03].BIT.IEN4 = 1;         // CMT0(vect=28) ݋

	CMT0.CMCOR = 0xFFFF;                // RyA}b`@Zbg
	CMT0.CMCNT = 0;                     // RyA}b`JE^ Zbg
	CMT.CMSTR0.BIT.STR0 = 0;            // 0FCMT0.CMCNTJE^̃JEg~
	
	
	// CMT1 --------------------------------------------------------------------
	
	CMT1.CMCR.BIT.CKS = 0;              // NbNI 1FPCLK/8
	CMT1.CMCR.BIT.CMIE = 1;             // 1FRyA}b`荞݁iCMInj

	ICU.IR[29].BIT.IR = 0;              // ݃Xe[^XWX^Zbg
	ICU.IPR[0x05].BIT.IPR = 0xA;        // ݃x 15(ō)
	ICU.IER[0x03].BIT.IEN5 = 1;         // CMT1(vect=29) ݋

	CMT1.CMCOR = 1000;                  // RyA}b`@Zbg
	CMT1.CMCNT = 0;                     // RyA}b`JE^ Zbg
	//CMT.CMSTR0.BIT.STR1 = 0;          // 0FCMT1.CMCNTJE^̃JEg~
	

	
	// MTU --------------------------------------------------------------------
	
	SYSTEM.MSTPCRA.BIT.MSTPA8 = 0;    // MTUjbg1    0FW[XgbvԂ̉	
	
	//MTU1-----
	IOPORT.PFDMTU.BIT.MTUS6 = 1;      // PD2MTIC11W-B[qƂđI
	MTU11.TCRW.BIT.TPSC = 0x3;        // ^C}vXP[I  NbNFPCLK ^64 ŃJEg
	MTU11.TIORW.BYTE = 0x13;          // GbWŃCvbgLv`
	
	MTU11.TIER.BIT.TGIE5W = 1;        // 1FTGI11W荞ݗv
	ICU.IR[169].BIT.IR = 0;           // ݃Xe[^XWX^Zbg
	ICU.IPR[0x66].BIT.IPR = 0xF;      // ݃x 15(ō)
	ICU.IER[0x15].BIT.IEN1 = 1;       // TGIW11(vect=169) ݋
	
	MTU11.TSTR.BYTE = 0x1;            // JE^X^[gWrbg@JEg
	
	
	//MTU6------
	MTUB.TSTR.BIT.CST0 = 0;           // MTU6JE^~@
	MTU6.TMDR.BIT.MD = 0;             // [hI m[}[h
	MTU6.TMDR.BIT.BFA = 0;            // TGRATGRCWX^͒ʏ퓮
	MTU6.TCR.BIT.TPSC = 0x3;          // ^C}vXP[I  NbNFPCLK ^64 ŃJEg
	MTU6.TCR.BIT.CCLR = 0x1;          // TGRÃRyA}b`^CvbgLv`TCNTNA
	MTU6.TCR.BIT.CKEG = 0x0;          // オGbWŃJEg
	MTU6.TIORH.BYTE = 0x00;           // MTIOC6A̋@\ o͋֎~
	MTU6.TIORL.BYTE = 0x00;           // MTIOC6C̋@\ o͋֎~
	
	MTU6.TIER.BIT.TGIEA = 1;          // 荞ݗviTGIAj
	ICU.IR[142].BIT.IR = 0;           // ݃Xe[^XWX^Zbg
	ICU.IPR[0x5C].BIT.IPR = 0xE;      // ݃x 15(ō)
	ICU.IER[0x11].BIT.IEN6 = 1;       // TGIA6(vect=142) ݋
	
	
	// AD --------------------------------------------------------------------
	
	SYSTEM.MSTPCRA.BIT.MSTPA23 = 0;   // 10rbgA/DRo[^    0FW[XgbvԂ̉	
	AD0.ADCR.BIT.MODE = 0;            // 샂[h@VO[h
	AD0.ADCR.BIT.CKS = 1;             // NbNI  PCLK/4
	AD0.ADCR.BIT.TRGS = 0;            // \tgEFAgK
	AD0.ADDPR.BIT.DPSEL = 0;          // f[^LSBl
	AD0.ADCSR.BIT.ADIE = 1;           // A/D荞݋
	
	ICU.IR[98].BIT.IR = 0;            // ݃Xe[^XWX^Zbg
	ICU.IPR[0x44].BIT.IPR = 0xF;      // ݃x 15(ō)
	ICU.IER[0x0C].BIT.IEN2 = 1;       // ADI0(vect=98) ݋	
	
	AD0.ADCSR.BIT.CH = 0;             // AN0I
	AD0.ADCSR.BIT.ADST = 1;           // ANϊJn (l擾)

	
	// DA --------------------------------------------------------------------
	
	// DA1
	SYSTEM.MSTPCRA.BIT.MSTPA19 = 0;    // DAjbg    0FW[XgbvԂ̉	
	DA.DADPR.BIT.DPSEL = 0;            // 0FD/Af[^WX^LSBl
	DA.DACR.BIT.DAE = 0;               //  0F`l0A1D/Aϊʐ
	DA.DACR.BIT.DAOE1 = 0;             // `l1̃AiOóiDA1j
	
	


	
	while(1){
			
		WDT.WRITE.WINA = 0x5A00;          // WDT XV
		
		// ͂PꂽƂ̏
		if((PORTD.PORT.BIT.B2 == 1) && ((CMT0.CMCNT > 0) || (cmt0_cnt > 0))){
			
			mtu6_cnt = cmt0_cnt / 2;      // 1/2
			MTU6.TGRA = CMT0.CMCNT/ 2;    // 1/2

			if((cmt0_cnt > 0)&&(cmt0_cnt % 2 != 0)){  // 0.5̏
				
				if(MTU6.TGRA <= 0x7FFF){
					MTU6.TGRA = MTU6.TGRA + 0x7FFF;
				}else{
					mtu6_cnt++;
					MTU6.TGRA = MTU6.TGRA - 0x7FFF;
				};
			};	
			
			cmt0_cnt = 0;      // ꂽԃJE^ Zbg
			CMT0.CMCNT = 0;    // ꂽԃJE^ Zbg
			
			PORTA.DR.BIT.B0 = 1;         // ó@LED1 ON
			
			MTU6.TCNT = 0;
			MTUB.TSTR.BIT.CST0 = 1;      // MTU6 ^C} X^[g

		};		

	};
	
}


// ͂Q 荞ݏ@IRQ14
void init_irq14(void){
	
	PORTA.DR.BIT.B2 = ~PORTA.DR.BIT.B2;   // ó@LED2 ON/OFF ]
	
	CMT.CMSTR0.BIT.STR1 = PORTA.DR.BIT.B2;     // 0FCMT1.CMCNTJE^̃JEgON
	DA.DACR.BIT.DAOE1 = PORTA.DR.BIT.B2;       // `l1̃AiOóiDA1j
	sin_cnt = 0;                               // singvbgpJE^
	
}


// o͂P MTU6 荞ݏ
// LED1 ON JEg
void init_mtu6(void){
	
	if(mtu6_cnt > 0){
		mtu6_cnt--;                 // JEg@fNg
		MTU6.TGRA = 0xFFFE;         // ^C}RyA őɃZbg
		
	}else{
		MTUB.TSTR.BIT.CST0 = 0;     // MTU6JE^X^[g@JEg
		PORTA.DR.BIT.B0 = 0;        // ó@LED1 OFF
	};    
	
}


// ͂P MTU11 荞ݏ
// {^̏ԑJڏ
void init_mtu11(void){
	
	if(PORTD.PORT.BIT.B2 == 0){    // ꂽ
	
		cmt0_cnt = 0;                    // JE^@Zbg
		CMT0.CMCNT = 0;                  // RyA}b`JE^ Zbg
		CMT.CMSTR0.BIT.STR0 = 1;         // 1FCMT0.CMCNTJE^̃JEgJn
		
		if(MTUB.TSTR.BIT.CST0 == 1){     // MTU6 ^C}쒆̏ꍇ
			MTUB.TSTR.BIT.CST0 = 0;  // MTU6 ^C} X^[g
			PORTA.DR.BIT.B0 = 0;     // ó@LED1 OFF
		};
	
	}else{    // ꂽ
		
		CMT.CMSTR0.BIT.STR0 = 0;         // 1FCMT0.CMCNTJE^̃JEg~	
		
	};
	
}


// ͂P CMT0 I[o[t[荞 
// ĂԂ̏
void init_cmt0(void){

	cmt0_cnt++;     // JE^@CNg
		
};




// CMT1 sing o͏ 
void init_cmt1(void){

	double buf_dbl = 0;
	double pi = 3.141593;
	
	// U̎Zo@AN0 ̓dl䗦Zo
	buf_dbl = an0_dat / an0_dat_MAX;
	if(buf_dbl > 1.0){
		buf_dbl = 1.0;
	};
	
	// o͒l̐		
	buf_dbl = start_level * buf_dbl 
	  * (1 - sin((double)(sin_cnt * 2 / sin_prot_max) * pi));


	DA.DADR1 = (unsigned int)buf_dbl & 0x3FF ;  // AiOo 10bit
	
	sin_cnt++;                         // JE^ CNg
	if(sin_cnt >= sin_prot_max){       // 1̏o͂IƂ
		
		sin_cnt = 0;
		AD0.ADCSR.BIT.ADST = 1;    // A/DϊJn
	};
		
};




// AiO
void init_AN0(void){

	an0_dat = AD0.ADDRA;    // AN0 ǂݍ   
		
};

